import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;

import java.awt.*;
import java.awt.event.*;

// Dialog to get inputs to mail the recorded voice file
public class MailDialog extends JDialog {
	private JTextField username = null;
	private JPasswordField password = null;
	private JTextField recipent = null;
	private JTextArea msg = null;
	private JButton bSend= null;
	private JButton bCancel= null;
	private JDialog dlg = null;
	private String fileName =null;
	private String fileTextName=null;
	
	public MailDialog(Frame parent, String fn, String ftn) {
		super(parent);
		
		setTitle("Mail");
		dlg = this;
		
		//set up the GUI widget for sender account, password, recipent address and message content
		fileName = fn;
		fileTextName = ftn;
		username = new JTextField("ac348");
		password = new JPasswordField("");
		recipent = new JTextField("");
		msg = new JTextArea("Thank you for using our intelligent multimedia system!\n\nHope you enjoy using the system!");
		
		setLayout(new BorderLayout());
		
		JPanel panel = new JPanel();
		panel.setLayout(new GridLayout(4,2));
		panel.add(new JLabel("Sender Account"));
		panel.add(username);
		panel.add(new JLabel("Sender Password"));
		panel.add(password);
		panel.add(new JLabel("Recipent Address"));
		panel.add(recipent);
		panel.add(new JLabel("Message"));
		panel.add(new JPanel());
		
		add(panel,BorderLayout.NORTH);
		Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
		msg.setBorder(raisedetched);
		add(msg,BorderLayout.CENTER);
		
		panel = new JPanel();
		panel.setLayout(new GridLayout(1,2));
		
		// create the send button to send the message
		bSend = new JButton("Send");
		bSend.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// send the message out 
				try {
					MailService.sendMessage(recipent.getText(), 
							username.getText(), 
							password.getText(),
							msg.getText(),
							fileName,
							fileTextName);
					JOptionPane.showMessageDialog(dlg,"Message sent!");
				} catch (Exception ex) {
					JOptionPane.showMessageDialog(dlg,"Fail to send the message!\n"+ex.getMessage());
				}
				
				dlg.dispose();
			}
		});
		
		// create the button to cancel the mail delivery
		bCancel = new JButton("Cancel");
		bCancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				dlg.dispose();
			}
		});

		panel.add(bSend);
		panel.add(bCancel);
		
		add(panel,BorderLayout.SOUTH);
		
		setPreferredSize(new Dimension(400,400));
		pack();
	}
}
