import java.awt.Graphics;
import java.awt.*;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
public class WavePanel extends JPanel {
	private int[] dataLt = null;
	private static final int WIDTH=400;
	
	// initialize the wave display panel
	public WavePanel() {
		 dataLt = new int [WIDTH+1];
		 this.setMinimumSize(new Dimension(WIDTH,200));
		 this.setMaximumSize(new Dimension(WIDTH,200));
		 this.setPreferredSize(new Dimension(WIDTH,200));
		 setBorder(BorderFactory.createLineBorder(Color.black));
		 
		 for (int i=0;i<WIDTH+1;i++) {
			 dataLt[i]=0;
		 }

		Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
		setBorder(raisedetched); 
	}
	
	// draw the wave graph
	public void paint(Graphics g) {
		// TODO Auto-generated method stub
		super.paint(g);
		for (int i=1;i<WIDTH+1;i++) {
			g.setColor(new Color(0x00,0x00,0xff));
			g.drawLine(i-1,199-dataLt[i-1],i,199-dataLt[i]);
		}
	}

	// append the new sample to the audio sample list
	public void addSample(int[] sample, int size) {
		System.arraycopy(dataLt,size,dataLt,0,WIDTH-size+1);
		for (int i=0;i<size;i++)
			dataLt[WIDTH-size+1+i]=sample[i]*199/255;
		repaint();
	}
	
}
